<template>
  <b-card>

    <b-row>

      <!-- User Info: Left col -->
      <b-col
        cols="21"
        xl="6"
        class="d-flex justify-content-between flex-column"
      >
        <!-- User Avatar & Action Buttons -->
        <div class="d-flex justify-content-start">
          <b-avatar
          
         
            src="https://www.hollyclark.org/wp-content/uploads/2020/04/Screen-Shot-2020-04-21-at-9.48.26-AM.png"
            size="104px"
            rounded
          />
          <div class="d-flex flex-column ml-1">
            <div class="mb-1">
              <h2 class="mb-0">
                {{ activitieData.name }} 
              </h2>
                 
            </div>

            
            <div>
              <b-progress
                :value="activitieData.percentage_advance"
                max="100"
                height="15px"
                :variant="percentageVariant(activitieData.percentage_advance)"
                striped
          
              />
              {{activitieData.percentage_advance}} %

            </div>
            <div>
              <b-card style="max-width: 25rem;" >
                <feather-icon
                  icon="AlignRightIcon"
                  class="mr-75"
                />
                <span class="font-weight-bold">Descripción:</span><br>
                {{ activitieData.description }}
              </b-card>
            </div>
        
              
           
            <br>
            <div class="d-flex flex-wrap">
              <b-button
                v-if="checkEditActivitiePermission()"
                :to="{ name: 'apps-project-activities-edit', params: { activitie: this.$route.params.activitie, id:this.$route.params.id } }"
                variant="primary"
              >
                Editar
              </b-button>

              <b-button
                variant="outline-danger"
                class="ml-1"
                v-if="activitieData.status && (activitieData.status.id === 1 || activitieData.status.id === 2) && (hasPermission('edit_project_activities') || activitieData.project.manager_id === userId)"
                @click="deleteActivitie($route.params.activitie)"
              >
                Cancelar
              </b-button>

              <b-button
                class="ml-1"
                :to="{name:'apps-projects-view' ,params: { id:this.$route.params.id }}"
              >
                Regresar
              </b-button>

              <b-button
                v-if="activitieData.status && activitieData.status.name=='Nueva'"
                variant="outline-success"
                class="ml-1"
                @click="showModal"
              >
                Iniciar
              </b-button>

            </div>
            
          </div>
        </div>

        
      </b-col>

      <!-- Right Col: Table -->
      <b-col
        cols="12"
        xl="6"
      >
        <table class="mt-2 mt-xl-0 w-100">
      
          <tr>
            <th class="pb-50">
              <feather-icon
                icon="StarIcon"
                class="mr-75"
              />
              <span class="font-weight-bold">Encargado:</span>
            </th>
            <td class="pb-50 text-capitalize" v-if="activitieData.user_manager">
              {{ activitieData.user_manager.name }} {{activitieData.user_manager.last_name}}
            </td>
          </tr>
          <tr>
            <th class="pb-50">
              <feather-icon
                icon="CheckIcon"
                class="mr-75"
              />
              <span class="font-weight-bold">Status:</span>
            </th>
            <td class="pb-50 text-capitalize" v-if="activitieData.status">
              {{ activitieData.status.name }}
            </td>
          </tr>
          <tr>
            <th class="pb-50">
              <feather-icon
                icon="ClockIcon"
                class="mr-75"
              />
              <span class="font-weight-bold">Duración estimada (horas):</span>
            </th>
            <td class="pb-50 text-capitalize">
              {{ activitieData.estimated_time }}
            </td>
          </tr>
          <tr>
            <th class="pb-50">
              <feather-icon
                icon="ClockIcon"
                class="mr-75"
              />
              <span class="font-weight-bold">Duración real (horas):</span>
            </th>
            <td class="pb-50 text-capitalize">
              {{ activitieData.real_time }} 
            </td>
          </tr>
          <tr>
            <th class="pb-50">
              <feather-icon
                icon="FlagIcon"
                class="mr-75"
              />
              <span class="font-weight-bold">Fecha de inicio:</span>
            </th>
            <td class="pb-50">
              {{ activitieData.start_date }}
            </td>
          </tr>
          <tr>
            <th>
              <feather-icon
                icon="FlagIcon"
                class="mr-75"
              />
              <span class="font-weight-bold">Fecha de terminación estimada:</span>
            </th>
            <td>
              {{ activitieData.estimated_end_date }}
            </td>
          </tr>
          <tr v-if="activitieData.end_date">
            <th class="pb-50">
              <feather-icon
                icon="FlagIcon"
                class="mr-75"
              />
              <span class="font-weight-bold">Fecha de terminación final:</span>
            </th>
            <td class="pb-50">
              {{ activitieData.end_date }}
            </td>
          </tr>
        </table>
      </b-col>
    </b-row>
    <modal-start-activitie @success="reload" :idActivitie="activitieData.id" :idProject="activitieData.project_id"></modal-start-activitie>
  </b-card>
</template>

<script>
import {
  BCard, BButton, BAvatar, BRow, BCol,BProgress,
} from 'bootstrap-vue'
import ModalStartActivitie from '../advance_activitie/ModalStartActivie.vue'

export default {
  name:'activitie-view-info-card',
  methods: {
  },
  components: {
    BCard, BButton, BRow, BCol, BAvatar,BProgress,ModalStartActivitie
  },
  props: {
    activitieData: {
      type: Object,
      required: true,
    },
  },
  data(){
    return{
      editPermission:'',
      userId:''
    }
  },
  methods:{
    deleteActivitie(activitie){
        this.$swal({
          title: '¿Está seguro de cancelar la actividad?',
          text: "La actividad será marcada como cancelada!",
          icon: 'warning',
          showCancelButton: true,
          confirmButtonText: 'Si, cancelar!',
          customClass: {
            confirmButton: 'btn btn-primary',
            cancelButton: 'btn btn-outline-danger ml-1',
          },
          buttonsStyling: false,

        }).then(result => {
          if (result.value) {
            this.$http.get('project/activities/delete',{params:{activitie:activitie}}).then(res=>{
              this.$swal({
                  icon: 'success',
                  title: 'Cancelada!',
                  text: 'La actividad ha sido cancelada.',
                  customClass: {
                    confirmButton: 'btn btn-success',
                  },
                })
              this.activitieData.status.name='Cancelada'
              this.$emit('success', true)
            }).catch(err=>{
              console.log(err)
            })
        } else {
            this.$swal({
              title: 'Cancelado',
              text: 'El registro esta a salvo :)',
              icon: 'error',
              customClass: {
                confirmButton: 'btn btn-success',
              },
            })
          }
      })
      } ,

    showModal(){
      this.$bvModal.show('modal-startActivitie')
    },
    reload(e){
      if(e){
        this.activitieData.status.name='Abierta'
        this.$emit('success', true)
      }
    },
    checkEditActivitiePermission(){
      let userData = JSON.parse(localStorage.userData)
   
      if(this.activitieData.project && this.activitieData.status){
        if ((this.activitieData.status.name === 'Abierta' || this.activitieData.status.name === 'Nueva' ) && (userData.permissions.find( permission => permission.name === 'edit_project_activities' ) || userData.id === this.activitieData.project.manager_id || userData.id === this.activitieData.manager_id )) {
          return true
        } else if((userData.permissions.find( permission => permission.name === 'edit_project_activities' ))){
          return true
        }else {
          return false
        }
      }
           
    },
    percentageVariant(percentage){
      if(percentage <= 30){
        return 'primary'
      }else if(percentage > 30 && percentage <= 70){
        return 'warning'
      }else if(percentage > 70 && percentage < 100){
        return 'info'
      }else if(percentage === 100){
        return 'success'
      }
    }
  
    
  },
  mounted(){
    let userData = JSON.parse(localStorage.userData)
    this.userId = userData.id
  }
}
</script>

<style>

</style>
